/*
FILE:     ndb_ddl_format_parser.y
*/
/*
VERSION:  0.900-beta
*/
/*
DATE:     12/16/2003
*/
/*
  Comments and Questions to: sw-help@rcsb.rutgers.edu
*/
/*
COPYRIGHT 1999-2003 Rutgers - The State University of New Jersey

This software is provided WITHOUT WARRANTY OF MERCHANTABILITY OR
FITNESS FOR A PARTICULAR PURPOSE OR ANY OTHER WARRANTY, EXPRESS OR
IMPLIED.  RUTGERS MAKE NO REPRESENTATION OR WARRANTY THAT THE
SOFTWARE WILL NOT INFRINGE ANY PATENT, COPYRIGHT OR OTHER
PROPRIETARY RIGHT.

The user of this software shall indemnify, hold harmless and defend
Rutgers, its governors, trustees, officers, employees, students,
agents and the authors against any and all claims, suits,
losses, liabilities, damages, costs, fees, and expenses including
reasonable attorneys' fees resulting from or arising out of the
use of this software.  This indemnification shall include, but is
not limited to, any and all claims alleging products liability.
*/
/*
               PDB SOFTWARE LICENSE AGREEMENT

BY CLICKING THE ACCEPTANCE BUTTON OR INSTALLING OR USING 
THIS "SOFTWARE, THE INDIVIDUAL OR ENTITY LICENSING THE  
SOFTWARE ("LICENSEE") IS CONSENTING TO BE BOUND BY AND IS 
BECOMING A PARTY TO THIS AGREEMENT.  IF LICENSEE DOES NOT 
AGREE TO ALL OF THE TERMS OF THIS AGREEMENT
THE LICENSEE MUST NOT INSTALL OR USE THE SOFTWARE.

1. LICENSE AGREEMENT

This is a license between you ("Licensee") and the Protein Data Bank (PDB) 
at Rutgers, The State University of New Jersey (hereafter referred to 
as "RUTGERS").   The software is owned by RUTGERS and protected by 
copyright laws, and some elements are protected by laws governing 
trademarks, trade dress and trade secrets, and may be protected by 
patent laws. 

2. LICENSE GRANT

RUTGERS grants you, and you hereby accept, non-exclusive, royalty-free 
perpetual license to install, use, modify, prepare derivative works, 
incorporate into other computer software, and distribute in binary 
and source code format, or any derivative work thereof, together with 
any associated media, printed materials, and on-line or electronic 
documentation (if any) provided by RUTGERS (collectively, the "SOFTWARE"), 
subject to the following terms and conditions: (i) any distribution 
of the SOFTWARE shall bind the receiver to the terms and conditions 
of this Agreement; (ii) any distribution of the SOFTWARE in modified 
form shall clearly state that the SOFTWARE has been modified from 
the version originally obtained from RUTGERS.  

2. COPYRIGHT; RETENTION OF RIGHTS.  

The above license grant is conditioned on the following: (i) you must 
reproduce all copyright notices and other proprietary notices on any 
copies of the SOFTWARE and you must not remove such notices; (ii) in 
the event you compile the SOFTWARE, you will include the copyright 
notice with the binary in such a manner as to allow it to be easily 
viewable; (iii) if you incorporate the SOFTWARE into other code, you 
must provide notice that the code contains the SOFTWARE and include 
a copy of the copyright notices and other proprietary notices.  All 
copies of the SOFTWARE shall be subject to the terms of this Agreement.  

3. NO MAINTENANCE OR SUPPORT; TREATMENT OF ENHANCEMENTS 

RUTGERS is under no obligation whatsoever to: (i) provide maintenance 
or support for the SOFTWARE; or (ii) to notify you of bug fixes, patches, 
or upgrades to the features, functionality or performance of the 
SOFTWARE ("Enhancements") (if any), whether developed by RUTGERS 
or third parties.  If, in its sole discretion, RUTGERS makes an 
Enhancement available to you and RUTGERS does not separately enter 
into a written license agreement with you relating to such bug fix, 
patch or upgrade, then it shall be deemed incorporated into the SOFTWARE 
and subject to this Agreement. You are under no obligation whatsoever 
to provide any Enhancements to RUTGERS or the public that you may 
develop over time; however, if you choose to provide your Enhancements 
to RUTGERS, or if you choose to otherwise publish or distribute your 
Enhancements, in source code form without contemporaneously requiring 
end users or RUTGERS to enter into a separate written license agreement 
for such Enhancements, then you hereby grant RUTGERS a non-exclusive,
royalty-free perpetual license to install, use, modify, prepare
derivative works, incorporate into the SOFTWARE or other computer
software, distribute, and sublicense your Enhancements or derivative
works thereof, in binary and source code form.

4. FEES.  There is no license fee for the SOFTWARE.  If Licensee
wishes to receive the SOFTWARE on media, there may be a small charge
for the media and for shipping and handling.  Licensee is
responsible for any and all taxes.

5. TERMINATION.  Without prejudice to any other rights, Licensor
may terminate this Agreement if Licensee breaches any of its terms
and conditions.  Upon termination, Licensee shall destroy all
copies of the SOFTWARE.

6. PROPRIETARY RIGHTS.  Title, ownership rights, and intellectual
property rights in the Product shall remain with RUTGERS.  Licensee 
acknowledges such ownership and intellectual property rights and will 
not take any action to jeopardize, limit or interfere in any manner 
with RUTGERS' ownership of or rights with respect to the SOFTWARE.  
The SOFTWARE is protected by copyright and other intellectual 
property laws and by international treaties.  Title and related 
rights in the content accessed through the SOFTWARE is the property 
of the applicable content owner and is protected by applicable law.  
The license granted under this Agreement gives Licensee no rights to such
content.

7. DISCLAIMER OF WARRANTY.  THE SOFTWARE IS PROVIDED FREE OF 
CHARGE, AND, THEREFORE, ON AN "AS IS" BASIS, WITHOUT WARRANTY OF 
ANY KIND, INCLUDING WITHOUT LIMITATION THE WARRANTIES THAT IT 
IS FREE OF DEFECTS, MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE 
OR NON-INFRINGING.  THE ENTIRE RISK AS TO THE QUALITY AND 
PERFORMANCE OF THE SOFTWARE IS BORNE BY LICENSEE.  SHOULD THE 
SOFTWARE PROVE DEFECTIVE IN ANY RESPECT, THE LICENSEE AND NOT 
LICENSOR ASSUMES THE ENTIRE COST OF ANY SERVICE AND REPAIR.  
THIS DISCLAIMER OF WARRANTY CONSTITUTES AN ESSENTIAL PART OF 
THIS AGREEMENT.  NO USE OF THE PRODUCT IS AUTHORIZED HEREUNDER 
EXCEPT UNDER THIS DISCLAIMER.

8. LIMITATION OF LIABILITY.  TO THE MAXIMUM EXTENT PERMITTED BY
APPLICABLE LAW,  IN NO EVENT WILL LICENSOR BE LIABLE FOR ANY 
INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING 
OUT OF THE USE OF OR INABILITY TO USE THE SOFTWARE, INCLUDING, 
WITHOUT LIMITATION, DAMAGES FOR LOSS OF GOODWILL, WORK 
STOPPAGE, COMPUTER FAILURE OR MALFUNCTION, OR ANY AND ALL 
OTHER COMMERCIAL DAMAGES OR LOSSES, EVEN IF ADVISED OF THE
POSSIBILITY THEREOF. 
*/
/* 
  PURPOSE:    A DDL 2.1 compliant CIF file parser.
*/

%{
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "ndb_cifparse.h"
#include "ndb_misclib.h"
int ddl_format_lex(void);
void yyerror(char *s);
#if 0
void yyprint(FILE *file, int type, YYSTYPE value);
#endif
void ndb_ddl_format_process_item_name_list(CifHandle *Cif);
void ndb_ddl_format_process_value_list(CifHandle *Cif);
void ndb_ddl_format_process_item_name_value_pair(CifHandle *Cif);
void ndb_ddl_format_process_loop_declaration(CifHandle *Cif);
void ndb_ddl_format_process_item_name_list_save(CifHandle *Cif);
void ndb_ddl_format_process_value_list_save(CifHandle *Cif);
void ndb_ddl_format_process_item_name_value_pair_save(CifHandle *Cif);
void ndb_ddl_format_process_loop_declaration_save(CifHandle *Cif);
static int ddl_f_get_column_index(CifHandle *cif,int blockIndex, int categoryIndex, char *columnName);

static int   curItemNo, curValueNo, itemIndex;
static int   curItemNo2, curValueNo2, itemIndex2;
static char  tBufKeyword[MxNameLen];
static int   begin;

/**********************/
 int  *ddl_f_fieldList;
 int  *ddl_f_fieldList2;
 int  *ddl_f_newRow;

 char *ddl_f_pBufValue;
 char  ddl_f_BString[1];

 CifHandle ddl_f_Cif;
 CifHandle ddl_f_tmpCif;
 int ddl_f_NDBlineNo;
 CifHandle ddl_f_form;
extern int ddl_f_isSave;

%}
%union {
	char *TempBuffer;
}
%token <TempBuffer> ITEMNAME
%token <TempBuffer> VALUE
%token <TempBuffer> LOOP
%token <TempBuffer> DATABLOCK
%token <TempBuffer> UNKNOWN
%token <TempBuffer> MISSING
%token <TempBuffer> SAVE_BEGIN
%token <TempBuffer> SAVE_END
%type  <TempBuffer> ItemName Value 
%type  <TempBuffer> SaveBegin SaveEnd
%%

Datablocks :    Sections /* Assignments*/
             |   Datablocks  Datablock 
             ;

Datablock :    DatablockName Sections;

Sections:
            | Sections Section
;
Section:       Assignment
				 | SaveBegin Assignments SaveEnd
{}
;


Assignments:  /* empty */ 
             | Assignments error Assignment 
             | Assignments Assignment
             ;

Assignment:       ItemName Value  /* instance of a non-looped item name value pair */
{
  if (ddl_f_isSave)
	 ndb_ddl_format_process_item_name_value_pair_save(&ddl_f_tmpCif);
  ndb_ddl_format_process_item_name_value_pair(&ddl_f_Cif);
}
  |   ItemNameList ValueList
  ;


ItemNameList:  

  Loop  ItemName           /*  the beginning of a loop_ */
{
  if (ddl_f_isSave)
	 ndb_ddl_format_process_loop_declaration_save(&ddl_f_tmpCif);
  ndb_ddl_format_process_loop_declaration(&ddl_f_Cif);
}
  
  | ItemNameList ItemName 
{
  if (ddl_f_isSave)
	 ndb_ddl_format_process_item_name_list_save(&ddl_f_tmpCif);
  ndb_ddl_format_process_item_name_list(&ddl_f_Cif);
}
  ;


ValueList:  Value 
{
  if (ddl_f_isSave) {
	 ndb_cif_rewind_column(&ddl_f_tmpCif);
	 ndb_ddl_format_process_value_list_save(&ddl_f_tmpCif);
  }
  ndb_cif_rewind_column(&ddl_f_Cif);
  ndb_ddl_format_process_value_list(&ddl_f_Cif);
}
  | ValueList Value
{
  if (ddl_f_isSave)
	 ndb_ddl_format_process_value_list_save(&ddl_f_tmpCif);
  ndb_ddl_format_process_value_list(&ddl_f_Cif);
}
;

ItemName : ITEMNAME  
{
  strcpy(tBufKeyword,$1);
}
;

Loop :    LOOP
{
  curItemNo = 0;  curValueNo = 0;  itemIndex = 0;
}
;

Value:   VALUE 
{
  ddl_f_pBufValue = $1;
}
        | UNKNOWN 
{
  ddl_f_pBufValue = ".";
}
        | MISSING
{
  ddl_f_pBufValue = ddl_f_BString;
}
;

SaveBegin: SAVE_BEGIN
{
  begin=1;
  ndb_cif_init(&ddl_f_tmpCif);
  ndb_cif_new_datablock(&ddl_f_tmpCif,"save");
  ddl_f_pBufValue = $1;
}
;
SaveEnd:   SAVE_END
{
  ndb_cif_close(&ddl_f_tmpCif);
  ddl_f_pBufValue = $1;
}
;

DatablockName: DATABLOCK
{
  int idatablock;
  idatablock = ndb_cif_get_datablock_id(&ddl_f_Cif,&($1)[5]);
  if (idatablock == 0){

	 ndb_cif_new_datablock(&ddl_f_Cif,&($1)[5]);
  }
  else {
    ndb_cif_move_datablock(&ddl_f_Cif,&($1)[5]);
	 ndb_cif_reset_datablock(&ddl_f_Cif);
  }



  idatablock = ndb_cif_get_datablock_id(&ddl_f_form, &($1)[5]);
  if (idatablock == 0){

	 ndb_cif_new_datablock(&ddl_f_form,&($1)[5]);
  }
  else {
    ndb_cif_move_datablock(&ddl_f_form, &($1)[5]);
	 ndb_cif_reset_datablock(&ddl_f_form);
  }
 
  ndb_cif_new_category(&ddl_f_form,"data");
		ndb_cif_put_item_keyword(&ddl_f_form,"key");
  ndb_cif_new_category(&ddl_f_form,"category");
		ndb_cif_put_item_keyword(&ddl_f_form,"key");
  ndb_cif_new_category(&ddl_f_form,"item");
		ndb_cif_put_item_keyword(&ddl_f_form,"key");
}
;







%%

void yyerror(char *s)
/* ---------------------------------------------------------------------------
 * Purpose:  yyerror()
 * 
             Report the location of a parsing error...
 -----------------------------------------------------------------------------*/
 
{
  ndb_log_message(NDB_MSG_ERR,"%s near line %d\n", s, ddl_f_NDBlineNo);
}

void ndb_ddl_format_process_item_name_list(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
   Purpose: ndb_ddl_format_process_item_name_list()

            Registers the item keyword for the the current item in the 
	    current category.  Maintains an index array of "valid" keyword 
	    names in ddl_f_fieldList[].  This array is used to indirectly 
	    reference between keywords and values ...  
 * ----------------------------------------------------------------------*/
{

  int prevCategoryId, categoryId,datablockId;
  char itemKeyword[MxNameLen], categoryName[MxNameLen];
#if DEBUG
  ndb_log_message(NDB_MSG_DEBUG,"Processing item name list at line %d keyword %s", ddl_f_NDBlineNo, tBufKeyword);
#endif
  prevCategoryId = ndb_cif_current_category(ddl_f_Cif);
  categoryId = ndb_cif_get_category_name_from_item_name(ddl_f_Cif,categoryName, tBufKeyword);
  datablockId =ndb_cif_current_datablock(ddl_f_Cif);
   ddl_f_fieldList = (int *) realloc(ddl_f_fieldList, (curItemNo+1) * sizeof(int));
   ddl_f_newRow = (int *) realloc(ddl_f_newRow, (curItemNo+1) * sizeof(int));
  if (categoryId != 0 && categoryId == prevCategoryId) {
    ndb_cif_get_item_keyword_from_item_name(ddl_f_Cif,itemKeyword, tBufKeyword);
	 if (ddl_f_get_column_index(ddl_f_Cif,datablockId-1,categoryId-1,itemKeyword)==-1){
		ndb_cif_put_item_keyword(ddl_f_Cif,itemKeyword);
		itemIndex++;
		ddl_f_fieldList[curItemNo] = ddl_f_get_column_index(ddl_f_Cif,datablockId-1,categoryId-1,itemKeyword)+1;

		ddl_f_newRow[curItemNo] =  curItemNo+1;
	 }
	 else {
		ddl_f_fieldList[curItemNo] = ddl_f_get_column_index(ddl_f_Cif,datablockId-1,categoryId-1,itemKeyword)+1;
		ddl_f_newRow[curItemNo] =  curItemNo+1;
	 }
  }
  else {
    ndb_log_message(NDB_MSG_ERR,"Syntax error line %d with %s", ddl_f_NDBlineNo, tBufKeyword);

	 ddl_f_fieldList[curItemNo] = -1;
		
  }

  curItemNo++;
}

void ndb_ddl_format_process_value_list(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
     Purpose:  ndb_ddl_format_process_value_list()

               Add the current value to the appropriate column in the 
               the current row.  Start a new row if necessary.
 * ----------------------------------------------------------------------*/
{

  int fieldNo;
#if DEBUG
  ndb_log_message_text(NDB_MSG_DEBUG,"Processing value at line %d value %s",ddl_f_NDBlineNo, ddl_f_pBufValue);
#endif
  if (ddl_f_fieldList[curValueNo] != -1) {
    fieldNo = ddl_f_fieldList[curValueNo];
    if (ddl_f_newRow[curValueNo] == 1) ndb_cif_new_row(ddl_f_Cif);
    if (fieldNo != 0) ndb_cif_put_item_value(ddl_f_Cif,ddl_f_fieldList[curValueNo], ddl_f_pBufValue);
  }
  curValueNo++;

  if (curValueNo == curItemNo) {curValueNo = 0;}
}

void ndb_ddl_format_process_item_name_value_pair(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
      Purpose: ndb_ddl_format_process_item_name_value_pair()

               Assign the current value to its associated item name.
 * ----------------------------------------------------------------------*/
{

  int categoryId, tmpCategoryId, datablockId;
  char categoryName[MxNameLen], itemKeyword[MxNameLen];
#if DEBUG
  ndb_log_message(NDB_MSG_DEBUG,"Processing item name value pair at line %d name %s", ddl_f_NDBlineNo, tBufKeyword);
#endif
  tmpCategoryId = ndb_cif_current_category(ddl_f_Cif);
  datablockId =ndb_cif_current_datablock(ddl_f_Cif);
  categoryId = ndb_cif_get_category_name_from_item_name(ddl_f_Cif,categoryName,tBufKeyword);
  curItemNo  = 1;
  curValueNo = 0;
  itemIndex  = 1;
  if (categoryId == 0) {
    if (strcmp(categoryName,"")) {
      ndb_cif_new_category(ddl_f_Cif,categoryName);
		if (ddl_f_isSave==0) {
		  ndb_cif_move_category_by_id(&ddl_f_form,datablockId,1);
		  if (ndb_cif_item_row_1_key(&ddl_f_form,1,categoryName)==0) {
			 ndb_cif_new_row(&ddl_f_form);
			 ndb_cif_put_item_value(&ddl_f_form,1,categoryName);
		  }
		}

		if (ddl_f_isSave==1) {
		  ndb_cif_move_category_by_id(&ddl_f_form,datablockId,2);
		  if (ndb_cif_item_row_1_key(&ddl_f_form,1,categoryName)==0) {
			 ndb_cif_new_row(&ddl_f_form);
			 ndb_cif_put_item_value(&ddl_f_form,1,categoryName);
		  }
		}
		if (ddl_f_isSave==2) {
		  ndb_cif_move_category_by_id(&ddl_f_form,datablockId,3);
		  if (ndb_cif_item_row_1_key(&ddl_f_form,1,categoryName)==0) {
			 ndb_cif_new_row(&ddl_f_form);
			 ndb_cif_put_item_value(&ddl_f_form,1,categoryName);
		  }
		}

  tmpCategoryId = ndb_cif_current_category(ddl_f_Cif);
    }
    else {
      ndb_log_message(NDB_MSG_ERR, "Missing category name component in %s at line %d", 
	     tBufKeyword, ddl_f_NDBlineNo);
      return ;
    }
  }
  else if (tmpCategoryId != categoryId) {
	 if (!ddl_f_isSave)
		ndb_log_message(NDB_MSG_WARN,"Category %s at line %d already exist",categoryName, ddl_f_NDBlineNo);
	 ndb_cif_move_category(ddl_f_Cif,categoryId);
	 ddl_f_fieldList = (int *) realloc(ddl_f_fieldList, sizeof(int));
	 ddl_f_newRow = (int *) realloc(ddl_f_newRow, (curItemNo+1) * sizeof(int));
	 ndb_cif_get_item_keyword_from_item_name(ddl_f_Cif,itemKeyword, tBufKeyword);
	 ddl_f_fieldList[0] = ddl_f_get_column_index(ddl_f_Cif,datablockId-1,categoryId-1,itemKeyword)+1;
	 ddl_f_newRow[0] = 1;

	 ndb_ddl_format_process_value_list(ddl_f_Cif);  
    return;     
  }

  ndb_cif_get_item_keyword_from_item_name(ddl_f_Cif,itemKeyword, tBufKeyword);
 if (ddl_f_get_column_index(ddl_f_Cif,datablockId-1,tmpCategoryId-1,itemKeyword)==-1)
	ndb_cif_put_item_keyword(ddl_f_Cif,itemKeyword);
  ddl_f_fieldList = (int *) realloc(ddl_f_fieldList, sizeof(int));
  ddl_f_newRow = (int *) realloc(ddl_f_newRow, (curItemNo+1) * sizeof(int));
  ddl_f_fieldList[0] = ddl_f_get_column_index(ddl_f_Cif,datablockId-1,tmpCategoryId-1,itemKeyword)+1;
  if (begin == 0)
	 ddl_f_newRow[0] = 2; 
  else {
	 ddl_f_newRow[0] = ddl_f_get_column_index(ddl_f_Cif,datablockId-1,tmpCategoryId-1,itemKeyword)+1;
	 begin=0;
  }
  ndb_ddl_format_process_value_list(ddl_f_Cif);
}


void ndb_ddl_format_process_loop_declaration(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
     Purpose: ndb_ddl_format_process_loop_declaration()

              Handles initialization for a new loop, by creating a new 
              category and adding the current item name to this category.
 * ---------------------------------------------------------------------- */
{

  char  categoryName[MxNameLen];
  int   categoryId;
  int   datablockId;
#if DEBUG
  ndb_log_message(NDB_MSG_DEBUG,"Processing loop declaration at line %d value %s", ddl_f_NDBlineNo, tBufKeyword);
#endif

  categoryId = ndb_cif_get_category_name_from_item_name(ddl_f_Cif,categoryName, tBufKeyword);
  if (categoryId == 0) {
    ndb_cif_new_category(ddl_f_Cif,categoryName);
	 datablockId=ndb_cif_current_datablock(&ddl_f_form);
		if (ddl_f_isSave==0) {
		  ndb_cif_move_category_by_id(&ddl_f_form,datablockId,1);
		  if (ndb_cif_item_row_1_key(&ddl_f_form,1,categoryName)==0) {
			 ndb_cif_new_row(&ddl_f_form);
			 ndb_cif_put_item_value(&ddl_f_form,1,categoryName);
		  }
		}

		if (ddl_f_isSave==1) {
		  ndb_cif_move_category_by_id(&ddl_f_form,datablockId,2);
		  if (ndb_cif_item_row_1_key(&ddl_f_form,1,categoryName)==0) {
			 ndb_cif_new_row(&ddl_f_form);
			 ndb_cif_put_item_value(&ddl_f_form,1,categoryName);
		  }
		}
		if (ddl_f_isSave==2) {
		  ndb_cif_move_category_by_id(&ddl_f_form,datablockId,3);
		  if (ndb_cif_item_row_1_key(&ddl_f_form,1,categoryName)==0) {
			 ndb_cif_new_row(&ddl_f_form);
			 ndb_cif_put_item_value(&ddl_f_form,1,categoryName);
		  }
		}

    ndb_ddl_format_process_item_name_list(ddl_f_Cif);
  }
  else {
	 if (!ddl_f_isSave)
		ndb_log_message(NDB_MSG_WARN,"Category %s at line %d already exist",categoryName, ddl_f_NDBlineNo);

	 ndb_cif_move_category(ddl_f_Cif,categoryId);
    ndb_ddl_format_process_item_name_list(ddl_f_Cif);
  }
}

#if 0
void yyprint2(FILE *file, int type, YYSTYPE value)
{
  fprintf(file,"\nType  = %d\n",type);
  fprintf(file,"Value = %s\n",value.TempBuffer);
}
#endif



void ndb_ddl_format_process_item_name_list_save(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
   Purpose: ndb_ddl_format_process_item_name_list_save()

            Registers the item keyword for the the current item in the 
	    current category.  Maintains an index array of "valid" keyword 
	    names in ddl_f_fieldList2[].  This array is used to indirectly 
	    reference between keywords and values ...  
 * ----------------------------------------------------------------------*/
{
  int prevCategoryId, categoryId;
  char itemKeyword[MxNameLen], categoryName[MxNameLen];
#if DEBUG
  ndb_log_message(NDB_MSG_DEBUG,"Processing item name list at line %d keyword %s", ddl_f_NDBlineNo, tBufKeyword);
#endif
  prevCategoryId = ndb_cif_current_category(ddl_f_Cif);
  categoryId = ndb_cif_get_category_name_from_item_name(ddl_f_Cif,categoryName, tBufKeyword);
   ddl_f_fieldList2 = (int *) realloc(ddl_f_fieldList2, (curItemNo2+1) * sizeof(int));
  if (categoryId != 0 && categoryId == prevCategoryId) {
    ndb_cif_get_item_keyword_from_item_name(ddl_f_Cif,itemKeyword, tBufKeyword);
    ndb_cif_put_item_keyword(ddl_f_Cif,itemKeyword);
    itemIndex2++;
    ddl_f_fieldList2[curItemNo2] = itemIndex2;
  }
  else {
    ndb_log_message(NDB_MSG_ERR,"Syntax error in save frame, line %d with %s", ddl_f_NDBlineNo, tBufKeyword);
    ddl_f_fieldList2[curItemNo2] = -1;
  }
  curItemNo2++;

}

void ndb_ddl_format_process_value_list_save(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
     Purpose:  ndb_ddl_format_process_value_list_save()

               Add the current value to the appropriate column in the 
               the current row.  Start a new row if necessary.
 * ----------------------------------------------------------------------*/
{

  int fieldNo;
#if DEBUG
  ndb_log_message_text(NDB_MSG_DEBUG,"Processing value at line %d value %s",ddl_f_NDBlineNo, ddl_f_pBufValue);
#endif
  if (ddl_f_fieldList2[curValueNo2] != -1) {
    fieldNo = ddl_f_fieldList2[curValueNo2];
    if (fieldNo == 1) ndb_cif_new_row(ddl_f_Cif);
    if (fieldNo != 0) ndb_cif_put_item_value(ddl_f_Cif,ddl_f_fieldList2[curValueNo2], ddl_f_pBufValue);
  }
  curValueNo2++;

  if (curValueNo2 == curItemNo2) curValueNo2 = 0;
}

void ndb_ddl_format_process_item_name_value_pair_save(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
      Purpose: ndb_ddl_format_process_item_name_value_pair_save()

               Assign the current value to its associated item name.
 * ----------------------------------------------------------------------*/
{

  int categoryId, tmpCategoryId;
  char categoryName[MxNameLen], itemKeyword[MxNameLen];
#if DEBUG
  ndb_log_message(NDB_MSG_DEBUG,"Processing item name value pair at line %d name %s", ddl_f_NDBlineNo, tBufKeyword);
#endif
  tmpCategoryId = ndb_cif_current_category(ddl_f_Cif);
  categoryId = ndb_cif_get_category_name_from_item_name(ddl_f_Cif,categoryName,tBufKeyword);
  curItemNo2  = 1;
  curValueNo2 = 0;
  itemIndex2  = 1;
  if (categoryId == 0) {
    if (strcmp(categoryName,"")) {
      ndb_cif_new_category(ddl_f_Cif,categoryName);
    }
    else {
      ndb_log_message(NDB_MSG_ERR, "Missing category name component in %s at line %d", 
	     tBufKeyword, ddl_f_NDBlineNo);
      return ;
    }
  }
  else if (tmpCategoryId != categoryId) {
    ndb_log_message(NDB_MSG_ERR,"Category conflict between %s and %s at line %d",  
		    (*ddl_f_Cif).datablocks[0].categories[tmpCategoryId].categoryName,
		    categoryName,
		    ddl_f_NDBlineNo);
    return;
  }

  ndb_cif_get_item_keyword_from_item_name(ddl_f_Cif,itemKeyword, tBufKeyword);
  ndb_cif_put_item_keyword(ddl_f_Cif,itemKeyword);
  ddl_f_fieldList2 = (int *) realloc(ddl_f_fieldList2, sizeof(int));
  ddl_f_fieldList2[0] = ndb_cif_current_col(ddl_f_Cif);
  ndb_ddl_format_process_value_list_save(ddl_f_Cif);
}


void ndb_ddl_format_process_loop_declaration_save(CifHandle *ddl_f_Cif)
/* ----------------------------------------------------------------------
     Purpose: ndb_ddl_format_process_loop_declaration_save()

              Handles initialization for a new loop, by creating a new 
              category and adding the current item name to this category.
 * ---------------------------------------------------------------------- */
{

  char  categoryName[MxNameLen];
  int   categoryId;
#if DEBUG
  ndb_log_message(NDB_MSG_DEBUG,"Processing loop declaration at line %d value %s", ddl_f_NDBlineNo, tBufKeyword);
#endif

  curItemNo2 = 0;  curValueNo2 = 0;  itemIndex2 = 0;
  categoryId = ndb_cif_get_category_name_from_item_name(ddl_f_Cif,categoryName, tBufKeyword);
  if (categoryId == 0) {
    ndb_cif_new_category(ddl_f_Cif,categoryName);
    ndb_ddl_format_process_item_name_list_save(ddl_f_Cif);
  }
  else {
    ndb_log_message(NDB_MSG_ERR,"Duplicate category %s in save frame at line %d",categoryName, ddl_f_NDBlineNo);
  }
}






int ddl_f_get_column_index(CifHandle *cif,int blockIndex, int categoryIndex, char *columnName)
{
  /*
   *  Return the index of for 'columnName' in the data block and category 
   *  specified by 'blockIndex' and 'categoryIndex'.
   */

    int icol, k;
    icol = -1;
    for (k=0; k < (*cif).datablocks[blockIndex].categories[categoryIndex].numCol; k++) {
        if (!STRCMP(columnName,(*cif).datablocks[blockIndex].categories[categoryIndex].colNames[k])) {
            icol = k;
            break;
        }
    }
    return icol;
}


